

SL=get_streamlines('001_spd_tracts.Bfloat',[1.5 1.75 2.25]);

tract=SL{1000}'; %1000th tract out of total 10000 tracts
figure; plot3(tract(1,:),tract(2,:),tract(3,:),'.b')

% map x,y,z coordinates onto the unit interval [0,1]
[arc_length  para]=parameterize_arclength(tract);
figure;
subplot(3,1,1); plot(para, tract(1,:));
subplot(3,1,2); plot(para, tract(2,:));
subplot(3,1,3); plot(para, tract(3,:));

%cosine series representation in [0,1]
[wfs beta]=WFS_tracts(tract,para,19);
figure; plot3(wfs(1,:),wfs(2,:),wfs(3,:),'k')

% Simulation

t=0:0.1:10
tract=[t.*sin(t); t.*cos(t); t];
figure; plot3(tract(1,:),tract(2,:),tract(3,:),'.b')
%
[arc_length  para]=parameterize_arclength(tract);  %computing arclength
[wfs beta]=WFS_tracts(tract,para,19);  %computing cosine series expansion
hold on; plot3(wfs(1,:),wfs(2,:),wfs(3,:),'r')